chiark / gitweb /
test suite: Trigger on indirect dependencies
[dgit.git] / tests / lib
index 62e47ddac839fac8a177c7de22a54c38dd6746a8..bd06d20d21cc7364ce1e056777e5fd03e35b4b29 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -12,6 +12,7 @@ t-report-failure () {
        rc=$1
        cat <<END >&2
 TEST FAILED
+cwd: $PWD
 funcs: ${FUNCNAME[*]}
 lines: ${BASH_LINENO[*]}
 files: ${BASH_SOURCE[*]}
@@ -28,12 +29,15 @@ t-set-intree
 : ${DGIT_TEST_DEBUG=-D}
 export DGIT_TEST_DEBUG
 
-export GIT_COMMITTER_DATE='1440253867 +0100'
-export GIT_AUTHOR_DATE='1440253867 +0100'
+: ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
+
+export GIT_COMMITTER_DATE='1515000000 +0100'
+export GIT_AUTHOR_DATE='1515000000 +0100'
 
 root=`pwd`
 troot=$root/tests
 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
+export DGIT_TEST_TROOT=$troot
 
 tmp=$ADTTMP
 if [ x"$tmp" = x ]; then
@@ -51,6 +55,7 @@ tmp=`pwd`
 
 t-set-using-tmp
 
+test -f $tmp/.save-env || \
 env -0 >$tmp/.save-env
 
 ln -f $troot/ssh ssh
@@ -184,6 +189,13 @@ t-git-none () {
        (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
 }
 
+t-salsa-add-remote () {
+       local d=$tmp/salsa/$p
+       mkdir -p $d
+       (set -e; cd $d; git init --bare)
+       git remote add ${1-origin} $d
+}
+
 t-git-merge-base () {
        git merge-base $1 $2 || test $? = 1
 }
@@ -355,9 +367,11 @@ t-expect-fsck-fail () {
 }
 
 t-git-fsck () {
+       local fsckerrs=$(git rev-parse --git-dir)/dgit-test-fsck.errs
+
        set +e
        LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
-               | tee dgit-test-fsck.errs
+               | tee $fsckerrs
        ps="${PIPESTATUS[*]}"
        set -e
 
@@ -371,7 +385,7 @@ t-git-fsck () {
        pats+=(-e 'notice: No default references')
 
        set +e
-       grep -v "${pats[@]}" dgit-test-fsck.errs
+       grep -v "${pats[@]}" $fsckerrs
        rc=$?
        set -e
        case $rc in
@@ -385,13 +399,14 @@ t-fscks () {
        (
        shopt -s nullglob
        for d in $tmp/*/.git $tmp/git/*.git; do
-               cd "$d"
+               cd "${d%/.git}"
                t-git-fsck
        done
        )
 }
 
 t-ok () {
+       : '========================================'
        t-fscks
        echo ok.
 }
@@ -402,16 +417,30 @@ t-rm-dput-dropping () {
 
 t-dgit () {
        local dgit=${DGIT_TEST-dgit}
-       pwd
+       pwd >&2
        : '
 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
        $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
-               -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
-               -k39B13D8A $t_dgit_xopts "$@"
+ ${dgit_config_debian_alias-"--config-lookup-explode=dgit-distro.debian.alias-canon"} \
+ ${DGIT_GITDEBREBASE_TEST+--git-debrebase=}${DGIT_GITDEBREBASE_TEST} \
+               ${distro+${distro:+-d}}${distro--dtest-dummy} \
+               $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
+               -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $t_dgit_xopts "$@"
        : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
 '
 }
 
+t-dgit-manpage () {
+       local section=$1
+       local page=$2
+       (export LC_ALL=C.UTF-8
+        if [ "$DGIT_TEST_INTREE" ]; then
+               make -C $DGIT_TEST_INTREE $page.$section.view
+        else
+               man $section $page
+        fi)
+}
+
 t-diff-nogit () {
        diff --exclude=.git --exclude=.pc -ruN $*
 }
@@ -451,12 +480,12 @@ t-setup-done () {
        local savedirs=$2
        local importeval=$3
 
-       local import=IMPORT.${0##*/}
+       local import=IMPORT.${DGIT_TEST_TESTNAME-${0##*/}}
        exec 4>$tmp/$import.new
 
        local vn
        for vn in $savevars; do
-               perl >&4 -I. -MDebian::Dgit -e '
+               perl >&4 -"I$root" -MDebian::Dgit -e '
                        printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
                ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
        done
@@ -614,6 +643,21 @@ t-check-pushed-master () {
        if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
 }
 
+t-push-was-source-only () {
+        local f
+       t-files-notexist $tmp/incoming/${p}_${v}_*.deb \
+                         $tmp/incoming/${p}_${v}_*.udeb
+       # we permit _source.buildinfo files; see test_changes_source_only()
+       for f in $tmp/incoming/${p}_${v}_*.buildinfo; do
+            if [ -e $f ]; then
+                case "$f" in
+                    *_source.buildinfo) ;;
+                    *) fail "non-source-only file $f exists!" ;;
+                esac
+            fi
+        done
+}
+
 t-pushed-good () {
        local branch=$1
        local suite=${2:-sid}
@@ -775,6 +819,12 @@ t-822-field () {
        ' <$file
 }
 
+t-defdistro () {
+       export DGIT_TEST_DISTRO=''
+       distro=''
+       t-git-config dgit-suite.unstable.distro test-dummy
+}
+
 t-stunt-envvar () {
        local var=$1
        local tstunt=$2
@@ -798,7 +848,14 @@ t-tstunt--save-real () {
        local rc
        local real
        set +e
-       real=$(type -p "$f")
+       real=$(
+               p=":$PATH:"
+               p="${p/:"$tmp/tstunt":/:}"
+               p="${p%:}"
+               p="${p#:}"
+               PATH="$p"
+               type -p "$f"
+       )
        rc=$?
        set -e
 
@@ -948,12 +1005,16 @@ t-commit () {
        revision=$(( ${revision-0} + 1 ))
 }
 
+t-dch-commit () {
+       faketime @"${GIT_AUTHOR_DATE% *}" dch "$@"
+       git commit -m "dch $*" debian/changelog
+}
+
 t-git-config () {
        git config --global "$@"
 }
 
 t-drs () {
-       export DGIT_TEST_TROOT=$troot
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
@@ -1006,7 +1067,9 @@ t-dsd () {
 }
 
 t-policy-admin () {
+       : '(((((((((((((((((((((((((((((((((((((((('
        ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
+       : '))))))))))))))))))))))))))))))))))))))))'
 }
 
 t-policy-nonexist () {
@@ -1038,8 +1101,10 @@ t-debpolicy () {
 }
 
 t-policy-periodic () {
+       : '(((((((((((((((((((((((((((((((((((((((('
        ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
                test-dummy $drs_dispatch '' --cron
+       : '))))))))))))))))))))))))))))))))))))))))'
 }
 
 t-restrict () {
@@ -1067,6 +1132,8 @@ t-alt-test () {
        t-chain-test "${t#*-}"
 }
 
+t-git-config dgit.default.old-dsc-distro test-dummy
+
 case "$0" in
 */gnupg) ;;
 *)     t-setup-import gnupg    ;;